=== debian/changelog ===
mpqc3 (0.0~git20160216-6) unstable; urgency=medium

  * debian/control (Build-Depends): Bump required libint2-dev version to
    2.1.0-3.
  * debian/patches/cmake_libint_check.patch: Removed, no longer needed.

 -- Michael Banck <mbanck@debian.org>  Sat, 08 Oct 2016 15:17:41 +0200

mpqc3 (0.0~git20160216-5) unstable; urgency=medium

  * debian/patches/cmake_libint_check.patch: New patch, removes one check from
    the Libint detection which is no longer applicable (Closes: #839361).

 -- Michael Banck <mbanc@debian.org>  Sun, 02 Oct 2016 19:36:10 +0200

mpqc3 (0.0~git20160216-4) unstable; urgency=medium

  * debian/patches/remove_debug_output.patch: New patch, removes overly verbose
    output.
  * debian/control (mpqc3/Description): Mention that CASSCF-F12 and MRCI-F12
    are density-fitted as well.
  * debian/patches/continue_testsuite_on_failures.patch: New patch, continues
    running the test suite for other integral types on failures, taken from
    upstream revisions 77002df9 and 81a8a7ca.
  * debian/rules (override_dh_auto_configure): Print out CMakeError.log on
    failure.

 -- Michael Banck <mbanck@debian.org>  Sat, 01 Oct 2016 21:34:48 +0200

mpqc3 (0.0~git20160216-3) unstable; urgency=medium

  * debian/patches/check_for_psio_purge.patch: Updated to properly cleanup
    after psi3 computations.
  * debian/patches/psi3_default_directory.patch: New patch, runs psiclean
    executable from correct directory.
  * debian/control (mpqc3/Description): Add MRCI-F12 to capabilities.

 -- Michael Banck <mbanck@debian.org>  Fri, 19 Feb 2016 08:27:43 +0100

mpqc3 (0.0~git20160216-2) unstable; urgency=medium

  * debian/control (Build-Depends): Added libpsi3-dev and psi3.
  * debian/control (mpqc3/Depends): Added psi3.
  * debian/control (mpqc3/Description): Add CASSCF-F12 to capabilities.
  * debian/patches/check_for_psio_purge.patch: New patch, avoids post
    psicode-3.4.0 features.
  * debian/control (Build-Depends): Added libopenbabel-dev.

 -- Michael Banck <mbanck@debian.org>  Fri, 19 Feb 2016 00:40:43 +0100

mpqc3 (0.0~git20160216-1) unstable; urgency=medium

  * New upstream development snapshot.

 -- Michael Banck <mbanck@debian.org>  Wed, 17 Feb 2016 00:08:44 +0100

mpqc3 (0.0~git20160214-1) unstable; urgency=medium

  * New upstream development snapshot.
    + fixes a build failure on 32bit architectures; Closes: #814130.
  * debian/control (Build-Depends): Added libint2-dev.
  * debian/patches/fix_cmake_configure_error.patch: Refreshed.

 -- Michael Banck <mbanck@debian.org>  Sun, 14 Feb 2016 14:58:16 +0100

mpqc3 (0.0~git20150911-1) unstable; urgency=medium

  * Initial release.

 -- Michael Banck <mbanck@debian.org>  Sat, 06 Feb 2016 22:09:41 +0100
