=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export CXXFLAGS=-g -O2 -std=c++11
export OMPI_MCA_orte_rsh_agent=/bin/false

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DMPI_C_COMPILER=mpicc || cat */CMakeFiles/CMakeError.log

override_dh_auto_install:
	dh_auto_install
	mv $(CURDIR)/debian/tmp/usr/bin/mpqc \
	   $(CURDIR)/debian/tmp/usr/bin/mpqc3

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	-(cd obj-*/test; make check0)
endif
